<?php

namespace Pinpoint\ProductPersonalisation\Controller\Adminhtml\Pdf;

use Magento\Backend\App\Action;
use Magento\Backend\App\Action\Context;
use Magento\Framework\View\Result\PageFactory;

/**
 * Class Generate
 * @package Pinpoint\ProductPersonalisation\Controller\Adminhtml\Pdf
 */
class Generate extends Action
{
    /**
     * @var PageFactory
     */
    protected $resultPageFactory;

    /**
     * @var \Magento\Sales\Api\OrderRepositoryInterface
     */
    protected $orderRepository;

    /**
     * @var \Pinpoint\ProductPersonalisation\Model\Pdf\Generation
     */
    protected $pdf;

    /**
     * Generate constructor.
     * @param Context $context
     * @param PageFactory $resultPageFactory
     * @param \Magento\Sales\Api\OrderRepositoryInterface $orderRepository
     * @param \Pinpoint\ProductPersonalisation\Model\Pdf\Generation $pdf
     */
    public function __construct(
        Context $context,
        PageFactory $resultPageFactory,
        \Magento\Sales\Api\OrderRepositoryInterface $orderRepository,
        \Pinpoint\ProductPersonalisation\Model\Pdf\Generation $pdf
    ) {
        $this->orderRepository = $orderRepository;
        $this->pdf = $pdf;

        parent::__construct($context);
        $this->resultPageFactory = $resultPageFactory;
    }

    public function execute()
    {
        if ($orderId = $this->getRequest()->getParam('order_id')) {
            $order = $this->orderRepository->get($orderId);
            $productSku = $this->getRequest()->getParam('sku');
            foreach ($order->getItems() as $item) {
                if ($item->getSku() == $productSku) {
                    $pdf = $this->pdf->generatePrintRead($item);

                    header('Content-type: application/pdf');
                    echo $pdf->render(); exit;
                }
            }
        }
    }
}
